//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormHistory.h"
#include "History.h"
#include <assert.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmHistory *frmHistory;
//---------------------------------------------------------------------------
__fastcall TfrmHistory::TfrmHistory(TComponent* Owner, History *history, CallbackCall callbackCall)
	: TForm(Owner), history(history), callbackCall(callbackCall)
{
	assert(history);
	assert(callbackCall);
	history->addObserver(*this);
}
//---------------------------------------------------------------------------

void TfrmHistory::obsUpdate(Observable* o, Argument * arg)
{
	History* history = dynamic_cast<History*>(o);
	if (history)
	{
		//HistoryNotifyArgument* darg = dynamic_cast<HistoryNotifyArgument*>(arg);
		//assert(darg);
		const std::deque<History::Entry>& entries = history->GetEntries();
		lvHistory->Items->Count = entries.size();
		lvHistory->Invalidate();
	}
}

void __fastcall TfrmHistory::lvHistoryData(TObject *Sender, TListItem *Item)
{
	int id = Item->Index;
	const History::Entry &entry = history->GetEntries()[id];
	AnsiString ts;
	ts.sprintf("%02d  %02d:%02d:%02d",
        entry.timestamp.day,
		entry.timestamp.hour, entry.timestamp.min, entry.timestamp.sec);
	Item->Caption = ts;
	Item->SubItems->Add(entry.uri.c_str());
	if (entry.incoming)
	{
		if (entry.time > 0)
			Item->ImageIndex = 0;
		else
			Item->ImageIndex = 1;
	}
	else
	{
		if (entry.time > 0)
			Item->ImageIndex = 2;
		else
			Item->ImageIndex = 3;
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmHistory::lvHistoryDblClick(TObject *Sender)
{
	TListItem *item = lvHistory->Selected;
	if (item == NULL)
	{
		return;
	}
	int id = item->Index;
	const History::Entry &entry = history->GetEntries()[id];
	callbackCall(entry.uri.c_str());	
}
//---------------------------------------------------------------------------

